world
	fps = 40
	icon_size = 64
	view = "17x11"
	mob = /player

	New()
		..()

		spawn_bots()

	proc/spawn_bots()
		//puts 64 bots spread out all over the map
		for(var/i = 1 to 32)
			var/turf/loc = null
			while(1) //prevents spawning on dense objects
				loc = locate(rand(1, 64), rand(1, 64), 1)
				if(loc && !loc.density) break

			new/mob/bot(loc)

pixel_projectile/rubber_arrow
	//here's a basic projectile, its gonna bounce off of walls but not mobs!

	icon = 'demo/gfx/mob.dmi'
	icon_state = "missile"

	collide(atom/a)
		//bounce back off of hard surfaces
		if(isturf(a))
			var/turf/step_away = get_step_away(src, a)
			if(step_away)

				var/tmp
					dx = 0
					dy = 0
					dr = 0

				dx = (step_away.x * WORLD_ICON_SIZE) + WORLD_HALF_ICON_SIZE - src.px
				dy = (step_away.y * WORLD_ICON_SIZE) + WORLD_HALF_ICON_SIZE - src.py
				//root
				dr = sqrt(dx * dx + dy * dy)
				//vector x (amount to move x,y each frame)
				src.vx = dx / dr * src.velocity
				src.vy = dy / dr * src.velocity

				src.dir = get_dir_adv(src, step_away)

				spawn(2) del(src)
		else //its not a surface, so its an atom!
			spawn(get_speed_delay(src.velocity) - 1) del(src)

atom
	MouseDown()
		if(istype(usr, /player))
			var/player/p = usr
			p.AcquireTarget(src)

turf
	icon = 'gfx/turf.dmi'
	grass
		icon_state = "grass"
	wall
		icon_state = "wall"
		density = 1

player
	//holds the image reference displaying our target indicator
	var/tmp/image/target_image_ref = null

	//prevents us from firing too fast
	var/tmp/firing = 0

	verb/kill_bots()
		for(var/mob/bot/b in world)
			del(b)

	verb/kill_projectiles()
		for(var/pixel_projectile/p in world)
			del p

	verb/add_bots()
		world.spawn_bots()

	key_down(k, client/c)
		//handle keys defined else where in code
		..()

		//handle other key commands too
		if(k == "space")
			src.fire_projectile(100)
		if(k == "e")
			//loop the machine gun
			while(src.client.keys["e"])
				spawn src.fire_projectile(100)
				while(src.firing)
					sleep(world.tick_lag)
				sleep(world.tick_lag)

	proc/fire_projectile(count)
		if(!src.target) return
		if(src.firing) return

		src.firing = 1
		//fires a projectile at our target
		for(var/i = 1 to count)
			new/pixel_projectile/rubber_arrow(src.loc)
			sleep(world.tick_lag * 4)
		src.firing = 0

	proc/AcquireTarget(atom/a)
		if(a == src) return

		if(src.target == a)
			src.drop_target()
			src.client.images -= src.target_image_ref
			src.target_image_ref = null
		else
			src.drop_target()
			src.client.images -= src.target_image_ref
			src.target_image_ref = null
			src.set_target(a)
			src.target_image_ref = image('demo/gfx/target.dmi', a)
			src.client.images += src.target_image_ref